#include <cmath>

// (x) = exp(lngamma(x))
double lngamma(double xx)
{
	static double cof[6]={76.18009173,-86.50532033,24.01409822,
	-1.231739516,0.120858003e-2,-0.536382e-5};
	double x=xx-1.0; double tmp=x+5.5;
	tmp -= (x+0.5)*log(tmp); double ser=1.0;
	for (int j=0;j<=5;j++) { x += 1.0; ser += cof[j]/x; }
	return -tmp+log(2.50662827465*ser);
}
