// getloc.cpp C03A pvO
// Copyright (c) 2001 Tsutomu Saito All Rights Reserved

#include "getloc.h"
using namespace std;

// LOC Ɗ֐̐̃JEg
static void AddFuncLoc(map<string,pair<int,int> >& mp,
	const list<string>& stk,const string& scp,bool bFunc)
{
	string	s;
	list<string>::const_iterator	it;
	for (it=stk.begin();it!=stk.end();++it) {
		if (s.empty()) s = *it;
		else s = s + "::" + *it;
	}
	if (!scp.empty()) {
		if (s.empty()) s = scp;
		else s = s + "::" + scp;
	}
	if (s.empty()) s = "  global";
	pair<int,int>&	pr = mp[s];
	++pr.second;
	if (bFunc) ++pr.first;
}

inline bool IsIdentifier(const char* p)
{
	return isalpha(*p) || *p == '_';
}

// P̃XgNXʂ̊֐̐LOC ߂
void GetFuncLoc(const list<string>& lst,map<string,pair<int,int> >& mp)
{
	int				l, klv = 0;
	string			nam,scp;
	list<string>	stk;
	list<string>::const_iterator	it;
	mp.clear();
	for (it=lst.begin();it!=lst.end();++it) {
		const string&	w = *it;
		if (IsIdentifier(w.c_str())) {	// ʎq
			list<string>::const_iterator	it2 = it;
			++it2;
			string	ww = it2 == lst.end() ? "" : *it2;
			if (klv > 0) continue;
			if (w == "struct" || w == "class"
				|| w == "union" || w == "namespace") {
				if (ww == "{") nam = " none";
				else if (IsIdentifier(ww.c_str())) nam = ww;
			} else {
				if (ww == "::") {
					if (!scp.empty()) scp += "::";
					scp += w;
					++it;
				} else if (ww == "(") {	// ֐
					l = 0;	// () ǂݔ΂
					while (++it != lst.end()) {
						if (*it == "(") ++l;
						else if (*it == ")" && --l == 0) break;
					}
					if (it != lst.end()) {
						++it;
						if (it != lst.end() && *it == ":") {	// oCjVCU
							AddFuncLoc(mp,stk,scp,false);
							while (++it != lst.end())
								if (*it == "{") break;
						}
						--it;
					}
				} else {
					scp = "";
				}
			}
		} else if (w == "{") {
			if (klv == 0 && !nam.empty()) {	// NX錾
				stk.push_back(nam.c_str());
				nam = "";
			} else {						// ֐ or ubN
				++klv;
			}
			AddFuncLoc(mp,stk,scp,klv == 1);	// 'klv == 1' ͊֐̏ꍇ
			if (klv == 0) scp = "";	// ֐̓XR[vKv
		} else if (w == "}") {
			if (klv > 0) {
				if (--klv == 0) scp == ""; // ֐𔲂XR[v߂
			} else {
				stk.pop_back();
			}
		} else if (w == ";") {
			if (klv == 0) scp = "";
			nam = "";
			AddFuncLoc(mp,stk,scp,false);
		} else if (w == ":" || w == "#") {	// '::'  '##' ł͂Ȃ
			AddFuncLoc(mp,stk,scp,false);
		}
	}
}

// NXʂ̊֐̐LOC ̌ʂ𕶎ɂB
string toString(const char* fnam,const map<string,pair<int,int> >& mp)
{
	int		s1,s2;
	string	s;
	char	buf[80];
	sprintf(buf,"%17s func  loc\n",fnam);
	s = buf;
	map<string,pair<int,int> >::const_iterator	it;
	s1 = s2 = 0;
	for (it=mp.begin();it!=mp.end();++it) {
		const pair<int,int>&	pr = it->second;
		sprintf(buf,"%17s %4d %4d\n",
			it->first.c_str(),pr.first,pr.second);
		s += buf;
		s1 += pr.first;
		s2 += pr.second;
	}
	sprintf(buf,"%17s %4d %4d\n","total",s1,s2);
	s += buf;
	return s;
}
